{{define "docheader"}}
<!DOCTYPE html>
<html>
<head>
	<title>directory sample</title>

	<link rel="stylesheet" href="/static/style.css">
</head>
<body>
{{end}}

{{define "docfooter"}}

	<script src="/static/mithril.js"></script>
	<script src="/static/mithril-stream.js"></script>
	<script src="/static/underscore.js"></script>
	<script src="/static/classnames/index.js"></script>
	<script src="/static/zed.js"></script>

</body>
</html>
{{end}}


{{define "sample"}}
{{template "docheader" .}}
<main>
	
		{{with .Object}}
		{{$b := .}}		
		<header>
			<h1>{{$b.Name}}</h1>

		<nav>
			<ul class="list">
				{{if not $b.IsRoot}}
				<li class="parent"><a href="{{$b.Parent}}">&larr;&nbsp;parent</a></li>
				{{end}}

				{{range .Children}}
				<li><a href="{{$b.Url .}}">{{.}}</a></li>
				{{end}}
			</ul>
		</nav>

			{{if not $b.IsRoot}}


			{{with .Meta}}
			<section>
				<details>
					<summary>Meta</summary>

					{{range .}}
					<details class="attribute">
						<summary>Attribute <em>{{.Name}}</em></summary>
						<article class="widget">
							<form id="meta.{{.Id}}.delete" action="{{$.Object.Path}}" method="post" data-xhr="yes" data-xhr-method="delete">
								<input type="hidden" name="_method" value="delete">
								<input type="hidden" name="_aspect" value="meta">
								<input type="hidden" name="_id" value="{{.Id}}">
							</form>

							<form id="meta.{{.Id}}.update" action="{{$.Object.Path}}" method="post" data-xhr="yes" data-xhr-method="put">
								<input type="hidden" name="_method" value="put">
								<input type="hidden" name="_aspect" value="meta">
								<input type="hidden" name="meta.prefix" value="{{.Prefix}}">
								<input type="hidden" name="_id" value="{{.Id}}">
										
								<label>Value</label>
								{{ if eq .Type "text/markdown"}} 
								<textarea class="markdown" name="meta.value">{{.Value}}</textarea>
								{{else}}
								<input type="text" name="meta.value" value="{{.Value}}">
								{{end}}
							</form>

					</article>

					<div class="inline">
						<button form="meta.{{.Id}}.update" type="submit">update</button>
						<button form="meta.{{.Id}}.delete" type="submit">delete</button>
					</div>
				</details>
				{{end}}
				
		</details>
	</section>
	{{end}}

			<!-- action forms go here -->
			<article class="widget">
				<form id="form.delete" name="form.delete" action="{{.Path}}" method="post" data-xhr="yes" data-xhr-method="delete">
					<input type="hidden" name="_method" value="delete">
					<input type="hidden" name="_aspect" value="object">
				</form>
			</article>	
		
			<details>
				<summary>edit object meta</summary>
					
				<article class="widget">
					<form action="{{.Path}}" method="post" data-xhr="yes" data-xhr-method="post">
						<input type="hidden" name="_method" value="post">
						<input type="hidden" name="_aspect" value="meta">

						<input type="hidden" name="meta.disposition" value="text/plain">
						<input type="hidden" name="meta.modifier" value="none">

						<label>Prefix</label>
						<input type="text" name="meta.prefix" placeholder="example: local">

						<label>Type</label>
						<select name="meta.type">
							<option value="string/plain">string</option>
							<option value="string/delimited">delimited string</option>
							<option value="text/markdown">markdown</option>
						</select>

						<label>Name</label>
						<input type="text" name="meta.name" placeholder="example: foo">

						<label>Value</label>
						<input type="text" name="meta.value" placeholder="default value">

						<div class="inline">
							<button type="reset">clear</button>
							<button type="submit">add meta attribute</button>
						</div>
					</form>
				</article>

				<article class="widget">
				<form action="{{.Path}}" method="post" data-xhr="yes" data-xhr-method="post">
					<input type="hidden" name="_method" value="post">
					<input type="hidden" name="_aspect" value="object">
		
					<div class="inline">
						<label>Add a Child Object</label>
						<input type="text" name="object.name" required>
						<button class="small" type="submit">Add</button>
					</div>
				</form>
			</article>

			<article>
				<ul class="inline">
					<li><button form="form.delete" type="submit">delete with all children objects</button></li>
				</ul>	
			</article>

		</details>
		{{else}}
			<article class="widget">
				<form action="{{.Path}}" method="post" data-xhr="yes" data-xhr-method="post">
					<input type="hidden" name="_method" value="post">
					<input type="hidden" name="_aspect" value="object">
		
					<label>Add a Child Object</label>
					<input type="text" name="object.name" required>
	
					<button type="submit">Add</button>
				</form>
			</article>
		{{end}}
	 </header>
	{{end}}

	{{if not .Object.IsRoot}}
	<section>
		<details>
			<summary>Add an Attribute</summary>
		<article class="widget">
			<form action="{{.Object.Path}}" method="post" data-xhr="yes" data-xhr-method="post">
				<input type="hidden" name="_method" value="post">
				<input type="hidden" name="_aspect" value="attribute">
		
				<input type="hidden" name="attribute.disposition" value="text/plain">
				<input type="hidden" name="attribute.modifier" value="none">

				<label>Prefix</label>
				<input type="text" name="attribute.prefix" placeholder="example: local">


				<label>Type</label>
				<select name="attribute.type">
					<option value="string/plain">string</option>
					<option value="string/delimited">delimited string</option>
					<option value="text/markdown">markdown</option>
					<option value="datetime/date">date</option>
					<option value="datetime/time">time</option>
				</select>

				<label>Name</label>
				<input type="text" name="attribute.name" placeholder="example: foo">

				<label>Value</label>
				<input type="text" name="attribute.value">

				<div class="inline">
					<button type="reset">clear</button>
					<button type="submit">add attribute</button>
				</div>
			</form>
		</article>
	</details>
	</section>
	{{end}}




	{{range .Object.Groups}}
	<section>
		{{if .IsGlobal}}
		<details open>
			<summary>Attributes</summary>
		{{else}}
		<details>	
			<summary>Group: {{.Name}}</summary>
		{{end}}
		{{range .Attributes}}
		<details class="attribute">
			<summary>Attribute <em>{{.Name}}</em></summary>
			<article class="widget">
				<form id="attribute.{{.Id}}.delete" action="{{$.Object.Path}}" method="post" data-xhr="yes" data-xhr-method="delete">
					<input type="hidden" name="_method" value="delete">
					<input type="hidden" name="_aspect" value="attribute">
					<input type="hidden" name="_id" value="{{.Id}}">
				</form>

				<form id="attribute.{{.Id}}.update" action="{{$.Object.Path}}" method="post" data-xhr="yes" data-xhr-method="put">
					<input type="hidden" name="_method" value="put">
					<input type="hidden" name="_aspect" value="attribute">
					<input type="hidden" name="attribute.prefix" value="{{.Prefix}}">
					<input type="hidden" name="_id" value="{{.Id}}">
				
					<label>Value</label>
					{{if eq .Type "datetime/date"}}
					<input type="date" name="attribute.value" value="{{.Value}}">
					{{else if eq .Type "datetime/time"}}
					<input type="time" name="attribute.value" value="{{.Value}}">
					{{else if eq .Type "text/markdown"}}
					<textarea class="markdown" name="attribute.value">{{.Value}}</textarea>
					{{else}}
					<input type="text" name="attribute.value" value="{{.Value}}">
					{{end}}
				</form>

			</article>

			<div class="inline">
				<button form="attribute.{{.Id}}.update" type="submit">update</button>
				<button form="attribute.{{.Id}}.delete" type="submit">delete</button>
			</div>
			
		</details>
		{{end}}
		</details>
	</section>
	{{end}}


	<section>
		<article>	
			<form class="example" id="create.child.object" action="{{.Object.Path}}" method="post" data-xhr="yes" data-xhr-method="post">		
				<input type="hidden" name="_method" value="post">
				<input type="hidden" name="_aspect" value="object">

				<h1>Create Child Object</h1>

				<label>Object Name:</label>
				<input type="text" name="object.name" placeholder="leave blank for auto-naming">

				{{range .Object.Meta}}				
					<input type="hidden" name="meta.{{.Name}}" value="{{.Value}}">
				{{end}}

				{{range .Object.Groups}}
				{{if not .IsGlobal}}<fieldset><legend>{{.Name}}</legend>{{end}}
					{{range .Attributes}}
					<label>{{.Name}}</label>
					{{if eq .Type "datetime/date"}}
					<input type="date" name="{{.PrefixedName}}" placeholder="{{.Value}}">
					{{else if eq .Type "datetime/time"}}
					<input type="time" name="{{.PrefixedName}}" placeholder="{{.Value}}">
					{{else if eq .Type "text/markdown"}}
					<textarea class="markdown" name="{{.PrefixedName}}" placeholder="{{.Value}}"></textarea>
					{{else}}
					<input type="text" name="{{.PrefixedName}}" placeholder="{{.Value}}">
					{{end}}
					{{end}}
				{{if not .IsGlobal}}</fieldset>{{end}}
				{{end}}

				<div class="inline">
					<button form="create.child.object" type="reset">clear</button>
					<button form="create.child.object" type="submit">create object</button>
				</div>
			</form>
		</article>
	</section>




		<!-- example below -->
		<!--
		<section>
		<details class="attribute">
			<summary>edit Attribute <em>test</em></summary>	
		<article class="widget">
			<form action="/api/mock" method="post" data-xhr="yes" data-xhr-method="put">
				<input type="hidden" name="_method" value="put">

				<label>First name</label>
				<input type="text" name="firstname" value="Alice" required>

				<label>Last name</label>
				<input type="text" name="lastname" value="Wonder" required>

				<label>This is a label</label>
				<input data-reset="yes" type="text" name="some" value="orginal text" placeholder="this is some text">
			
				<label>This is a select</label>
				<select name="select">
					<option value="first" class="first">first</option>
					<option value="second">Second</option>
				</select>

				<label>This is some text</label>
				<textarea name="textarea">This is the content</textarea>

				<div class="inline">
					<button type="reset">clear</button>
					<button type="submit">update</button>	
				</div>
			</form>
		</article>
		</details>
		</section>
		-->

</main>

<template id="widget:first-last">
	<label>First name</label>
	<input type="text" name="firstname" required>

	<label>Last name</label>
	<input type="text" name="lastname" required>
</template>

<script>
document.addEventListener('DOMContentLoaded',function() {
	
	_.map(document.querySelectorAll("article.widget"),function(k) {
		m.mount(k,z.consume(k));
	});		

	_.map(document.querySelectorAll('a[data-xhr="yes"]'),function(k) {

		console.log("a.xhr ",k);
	});



});
</script>


{{template "docfooter" .}}
{{end}}
